import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Scanner;
import javax.swing.JOptionPane;

/**
 * Driver for Project: SearchingAlgorithms.
 * Description posted at http://darcy.rsgc.on.ca/ACES/ICS3U/1112ProgrammingTasks.html#Searching
 * Date: 2012 01 10
 * @author C. D'Arcy
 */


public class SearchingAlgorithms {
	private static String filename = "Music1.txt";
	private static Track[] library;

	/**
	 * Use the main method to maintain the iTunes library and
	 * handle the user's search queries
	 * @param args (any) input parameters (N/A)
	 * @throws FileNotFoundException
	 */
	public static void main(String[] args) throws FileNotFoundException {
		//Establish channel for reading the iTunes data
		FileReader file = new FileReader(filename);
		Scanner input = new Scanner(file);
		
		// The iTunes data is, ultimately, to be held in an array. However,
		// since we don't know how many records are in the database, we don't know
		// how large to make the array. This solution first reads the records (ultimately Track objects)
		// into an ArrayList first (which can expand as required) and then call
		// on its toArray() method to convert it to a fixed-size array.
		ArrayList<Track> temp = new ArrayList<Track>();
		// Dismiss the line containing the fields
		input.nextLine();
		// Read in one record at a time and pass the entire String to the Track constructor
		// for parsing into separate fields and add the object to the temporary ArrayList
		while (input.hasNext()) {
			temp.add(new Track(input.nextLine()));
		}

		// Create a fixed array of size equal to the temporary ArrayList container
		library = new Track[temp.size()];

		// Convert the ArrayList to an array
		temp.toArray(library);

		// Process user queries in a manner similar to the example
		// we studied from the textbook
		boolean done = false;
		while (!done) {
			String target = JOptionPane
					.showInputDialog("Enter name to search for, -1 to quit: ");
			if (target.equals("-1"))
				done = true;
			else {
				int pos = linearSearchByName(target);
				System.out.println("Found in position " + pos);
			}
		}

	}

	/**
	 * Accepts the name of a Track and returns the index of the 
	 * Track in the array. If not found, the method returns -1.
	 * @param name the name of the track to be located
	 * @return the index of the desired name or -1 if not found
	 */
	public static int linearSearchByName(String name) {

	}

}
